﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private B4XTable1 As B4XTable
	Private B4XTable2 As B4XTable
	Private lista1, lista2 As List
	Private B4XTableSelections1 As B4XTableSelections
	Private Button2 As B4XView
	Private Button3 As B4XView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	B4XTable1.AddColumn("Codigo", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable1.AddColumn("Articulo", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable1.AddColumn("Unidades", B4XTable1.COLUMN_TYPE_TEXT)
	
	B4XTable2.AddColumn("Codigo", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable2.AddColumn("Articulo", B4XTable1.COLUMN_TYPE_TEXT)
	B4XTable2.AddColumn("Unidades", B4XTable1.COLUMN_TYPE_TEXT)
	
	' Cargo la primera tabla
	lista1.Initialize
	lista1.Add(Array("100", "1", 10))
	lista1.Add(Array("100", "2", 1))
	lista1.Add(Array("100", "3", 10))
	lista1.Add(Array("100", "4", 10))
	lista1.Add(Array("100", "5", 5))
	lista1.Add(Array("100", "2", 10))
	B4XTable1.SetData(lista1)
	' Inicializo la manera en la que voy a realzar las diferencias
	B4XTableSelections1.Initialize(B4XTable1)
	B4XTableSelections1.Mode = B4XTableSelections1.MODE_MULTIPLE_LINES
	B4XTableSelections1.SelectedTextColor = xui.Color_red
	B4XTableSelections1.SelectionColor = xui.Color_Transparent
	
	
	' Cargo la segunda tabla con al que voy reliza las comparaciones
	lista2.Initialize
	lista2.Add(Array("100", "1", 5))
	lista2.Add(Array("100", "2", 10))
	lista2.Add(Array("100", "4", 10))
	lista2.Add(Array("100", "5", 6))
	lista2.Add(Array("100", "1", 10))
	B4XTable2.SetData(lista2)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub B4XTable1_CellClicked (ColumnId As String, RowId As Long)
'	B4XTableSelections1.CellClicked(ColumnId, RowId)
'	Dim row As Map
'	row = B4XTable1.GetRow(RowId)
'	Dim filtro As String
'	filtro = $"${B4XTable2.GetColumn("Articulo").SQLID} = ${row.Get("Articulo")}"$
'	B4XTable2.CreateDataView(filtro)
'	B4XTable2.Refresh
'	Log(B4XTable2.clvData.Size)
End Sub

Sub B4XTable1_DataUpdated
	B4XTableSelections1.Refresh
End Sub

Private Sub B4XTable2_CellClicked (ColumnId As String, RowId As Long)
'	Log(ColumnId & " " & RowId)
End Sub

Private Sub CompararTablas(t1 As B4XTable, t2 As B4XTable, fields As List)
	B4XTableSelections1.Clear
	Dim x, y, z As Int
	' Recorro todas las filas de la tabla origen
	For x = 1 To t1.Size
		Dim row1 As Map
		row1 = t1.GetRow(x)
		Y = 1
		Dim matches As Int = 0
		' Por cada fila de la tabla origen, hago la comparación contra todas las filas de la tabla secundaria buscanco si hay coincidencias en el/los campo/s solicitados
		Do Until y = t2.Size+1 Or matches = fields.Size
			Dim row2 As Map
			row2 = t2.GetRow(Y)
			matches = 0
			For z = 0 To fields.Size-1
				If row1.Get(fields.get(z)).As(String).EqualsIgnoreCase(row2.Get(fields.get(z)).As(String)) Then
					matches = matches + 1
				End If
			Next
			y = y + 1
		Loop
		' Sino hay tantas coincidencias como campos solicitados, entonces remarcamos la fila correspondiente...
		If matches < fields.Size Then B4XTableSelections1.CellClicked(fields.get(0).As(String), x)
	Next
End Sub

Private Sub Button2_Click
	' Defino el/los campos por los que voy a realizar las comparaciones
	Dim fields As List
	fields.Initialize
	fields.AddAll(Array As String("Articulo", "Unidades"))
	CompararTablas(B4XTable1, B4XTable2, fields)
End Sub

Private Sub Button1_Click
	' Defino el/los campos por los que voy a realizar las comparaciones
	Dim fields As List
	fields.Initialize
	fields.AddAll(Array As String("Articulo"))
	CompararTablas(B4XTable1, B4XTable2, fields)
End Sub

Private Sub Button3_Click
	B4XTableSelections1.Clear
End Sub